diff --git a/liboctave/array/dSparse.cc b/liboctave/array/dSparse.cc
--- a/liboctave/array/dSparse.cc
+++ b/liboctave/array/dSparse.cc
@@ -502,6 +542,871 @@ SparseMatrix::min (Array<octave_idx_type
 
 */
 
+SparseMatrix
+SparseMatrix::cummax (int dim, bool includenan) const
+{
+  SparseMatrix result;
+  dim_vector dv = dims ();
+  octave_idx_type nr = dv(0);
+  octave_idx_type nc = dv(1);
+
+  if (dim >= dv.ndims ())
+    return *this;
+
+  if (dim < 0)
+    dim = dv.first_non_singleton ();
+
+  if (nr == 0 || nc == 0 || dim >= dv.ndims ())
+    return SparseMatrix (nr, nc);
+
+  if (dim == 0)
+    {
+      octave_idx_type nel = 0;
+      for (octave_idx_type j = 0; j < nc; j++)
+        {
+          octave_idx_type i = cidx (j);
+          if (i < cidx (j+1) && ridx (i) == 0)
+            {
+              octave_idx_type expected_r = 0;
+              for (; i < cidx (j+1) && ridx (i) == expected_r; i++)
+                {
+                  if (data (i) > 0. || (octave::math::isnan (data (i))
+                                        && includenan))
+                    break;
+                  expected_r++;
+                }
+
+              if (i < cidx (j+1) && ridx (i) == expected_r)
+                {
+                  nel += nr;
+                  continue;
+                }
+              nel += expected_r;
+            }
+          for (; i < cidx (j+1); i++)
+            if (data (i) > 0. || (octave::math::isnan (data (i))
+                                  && includenan))
+              {
+                nel += nr - ridx (i);
+                break;
+              }
+        }
+
+      result = SparseMatrix (nr, nc, nel);
+      octave_idx_type ii = 0;
+      result.xcidx (0) = 0;
+
+      for (octave_idx_type j = 0; j < nc; j++)
+        {
+          octave_idx_type i = cidx (j);
+          if (i < cidx (j+1))
+            {
+              octave_idx_type last = 0;
+              bool zero_found = ridx (i) > 0;
+              double tmp_max = zero_found ? 0. : data (i++);
+
+              if (! zero_found
+                  && ((i < cidx (j+1) && ridx (i) > 1)
+                      || (i == cidx (j+1) && nr >= 2)))
+                {
+                  zero_found = true;
+                  if (0. > tmp_max
+                      || (octave::math::isnan (tmp_max) && ! includenan))
+                    {
+                      result.xdata (ii) = tmp_max;
+                      result.xridx (ii++) = 0;
+                      last = 1;
+                      tmp_max = 0.;
+                    }
+                }
+
+              for (; i < cidx (j+1); i++)
+                {
+                  if (data (i) > tmp_max
+                      || (includenan == octave::math::isnan (data (i))
+                          && includenan != octave::math::isnan (tmp_max)))
+                    {
+                      if (tmp_max != 0.)
+                        for (; last < ridx (i); last++)
+                          {
+                            result.xdata (ii) = tmp_max;
+                            result.xridx (ii++) = last;
+                          }
+                      last = ridx (i);
+                      tmp_max = data (i);
+                    }
+                  if (! zero_found
+                      && ((i + 1 < cidx (j+1) && ridx (i+1) > ridx (i) + 1)
+                          || (i + 1 == cidx (j+1) && ridx (i) < nr - 1)))
+                    {
+                      zero_found = true;
+                      if (0. > tmp_max
+                          || (octave::math::isnan (tmp_max) && ! includenan))
+                        {
+                          for (; last < ridx (i) + 1; last++)
+                            {
+                              result.xdata (ii) = tmp_max;
+                              result.xridx (ii++) = last;
+                            }
+                          last = ridx (i) + 1;
+                          tmp_max = 0.;
+                        }
+                    }
+                }
+              if (tmp_max != 0.)
+                for (; last < nr; last++)
+                  {
+                    result.xdata (ii) = tmp_max;
+                    result.xridx (ii++) = last;
+                  }
+            }
+          result.xcidx (j+1) = ii;
+        }
+    }
+  else
+    {
+      octave_idx_type nel = 0;
+
+      OCTAVE_LOCAL_BUFFER (octave_idx_type, expected_visit, nr);
+      OCTAVE_LOCAL_BUFFER (int8_t, max_sgn, nr);
+
+      for (octave_idx_type i = 0; i < nr; i++)
+        {
+          expected_visit[i] = 0;
+          max_sgn[i] = -1;
+        }
+
+      for (octave_idx_type j = 0; j < nc; j++)
+        for (octave_idx_type i = cidx (j); i < cidx (j+1); i++)
+          {
+            if (max_sgn[ridx (i)] <= 0)
+              {
+                bool end_of_zeros = (data (i) > 0.
+                                     || (octave::math::isnan (data (i))
+                                         && includenan));
+
+                if (max_sgn[ridx (i)] < 0)
+                  {
+                    if (expected_visit[ridx (i)] < j || end_of_zeros)
+                      {
+                        nel += expected_visit[ridx (i)];
+                        if (expected_visit[ridx (i)] < j)
+                          max_sgn[ridx (i)] = 0;
+                      }
+                    else
+                      expected_visit[ridx (i)]++;
+                  }
+                if (end_of_zeros)
+                  {
+                    max_sgn[ridx (i)] = 1;
+                    nel += nc - j;
+                  }
+              }
+          }
+
+      for (octave_idx_type i = 0; i < nr; i++)
+        if (max_sgn[i] < 0)
+          nel += expected_visit[i];
+
+      result = SparseMatrix (nr, nc, nel);
+      octave_idx_type ii = 0;
+      result.xcidx (0) = 0;
+
+      for (octave_idx_type i = cidx (0); i < cidx (1); i++)
+        {
+          result.xdata (ii) = data (i);
+          result.xridx (ii++) = ridx (i);
+        }
+      result.xcidx (1) = ii;
+
+      for (octave_idx_type j = 1; j < nc; j++)
+        {
+          octave_idx_type i = cidx (j);
+          octave_idx_type i_max = cidx (j+1);
+          bool i_lt_max = i < i_max;
+
+          octave_idx_type r = result.cidx (j-1);
+          octave_idx_type r_max = result.cidx (j);
+          bool r_lt_max = r < r_max;
+
+          while (i_lt_max || r_lt_max)
+            {
+              octave_quit ();
+              double i_val, r_val;
+              octave_idx_type row;
+
+              if (! r_lt_max || (i_lt_max && ridx (i) < result.ridx (r)))
+                {
+                  i_val = data (i);
+                  r_val = 0.;
+                  row = ridx (i++);
+                  i_lt_max = i < i_max;
+                }
+              else if (! i_lt_max || (r_lt_max && result.ridx (r) < ridx (i)))
+                {
+                  i_val = 0.;
+                  r_val = result.data (r);
+                  row = result.ridx (r++);
+                  r_lt_max = r < r_max;
+                }
+              else
+                {
+                  i_val = data (i);
+                  r_val = result.data (r);
+                  row = ridx (i++);
+                  i_lt_max = i < i_max;
+                  r++;
+                  r_lt_max = r < r_max;
+                }
+
+              double tmp;
+              if (includenan)
+                tmp = r_val >= i_val ? r_val : (octave::math::isnan (r_val)
+                                                ? r_val : i_val);
+              else
+                tmp = octave::math::max (r_val, i_val);
+              if (tmp != 0.)
+                {
+                  result.data (ii) = tmp;
+                  result.ridx (ii++) = row;
+                }
+            }
+          result.xcidx (j+1) = ii;
+        }
+    }
+
+  return result;
+}
+
+SparseMatrix
+SparseMatrix::cummax (Array<octave_idx_type>& idx_arg,
+                      int dim, bool includenan) const
+{
+  SparseMatrix result;
+  dim_vector dv = dims ();
+  octave_idx_type nr = dv(0);
+  octave_idx_type nc = dv(1);
+
+  if (dim >= dv.ndims ())
+    {
+      idx_arg.resize (dim_vector (nr, nc), 0);
+      return *this;
+    }
+
+  if (dim < 0)
+    dim = dv.first_non_singleton ();
+
+  idx_arg.resize (dim_vector (nr, nc));
+
+  if (nr == 0 || nc == 0 || dim >= dv.ndims ())
+    return SparseMatrix (nr, nc);
+
+  if (dim == 0)
+    {
+      octave_idx_type nel = 0;
+      for (octave_idx_type j = 0; j < nc; j++)
+        {
+          octave_idx_type i = cidx (j);
+          if (i < cidx (j+1) && ridx (i) == 0)
+            {
+              octave_idx_type expected_r = 0;
+              for (; i < cidx (j+1) && ridx (i) == expected_r; i++)
+                {
+                  if (data (i) > 0. || (octave::math::isnan (data (i))
+                                        && includenan))
+                    break;
+                  expected_r++;
+                }
+
+              if (i < cidx (j+1) && ridx (i) == expected_r)
+                {
+                  nel += nr;
+                  continue;
+                }
+              nel += expected_r;
+            }
+          for (; i < cidx (j+1); i++)
+            if (data (i) > 0. || (octave::math::isnan (data (i))
+                                  && includenan))
+              {
+                nel += nr - ridx (i);
+                break;
+              }
+        }
+
+      result = SparseMatrix (nr, nc, nel);
+      octave_idx_type ii = 0;
+      result.xcidx (0) = 0;
+      octave_idx_type i = cidx (0);
+
+      for (octave_idx_type j = 0; j < nc; j++)
+        {
+          double tmp_max = i < cidx (j+1) && ridx (i) == 0 ? data (i++) : 0.;
+          idx_arg.elem (0, j) = 0;
+          if (tmp_max != 0.)
+            {
+              result.xdata (ii) = tmp_max;
+              result.xridx (ii++) = 0;
+            }
+
+          for (octave_idx_type ir = 1; ir < nr; ir++)
+            {
+              double tmp = i < cidx (j+1) && ridx (i) == ir ? data (i++) : 0.;
+
+              if (tmp > tmp_max
+                  || (includenan == octave::math::isnan (tmp)
+                      && includenan != octave::math::isnan (tmp_max)))
+                {
+                  tmp_max = tmp;
+                  idx_arg.elem (ir, j) = ir;
+                }
+              else
+                idx_arg.elem (ir, j) = idx_arg.elem (ir - 1, j);
+              if (tmp_max != 0.)
+                {
+                  result.xdata (ii) = tmp_max;
+                  result.xridx (ii++) = ir;
+                }
+            }
+
+          result.xcidx (j+1) = ii;
+        }
+    }
+  else
+    {
+      octave_idx_type nel = 0;
+
+      OCTAVE_LOCAL_BUFFER (octave_idx_type, expected_visit, nr);
+      OCTAVE_LOCAL_BUFFER (int8_t, max_sgn, nr);
+
+      for (octave_idx_type i = 0; i < nr; i++)
+        {
+          expected_visit[i] = 0;
+          max_sgn[i] = -1;
+        }
+
+      for (octave_idx_type j = 0; j < nc; j++)
+        for (octave_idx_type i = cidx (j); i < cidx (j+1); i++)
+          {
+            if (max_sgn[ridx (i)] <= 0)
+              {
+                bool end_of_zeros = (data (i) > 0.
+                                     || (octave::math::isnan (data (i))
+                                         && includenan));
+
+                if (max_sgn[ridx (i)] < 0)
+                  {
+                    if (expected_visit[ridx (i)] < j || end_of_zeros)
+                      {
+                        nel += expected_visit[ridx (i)];
+                        if (expected_visit[ridx (i)] < j)
+                          max_sgn[ridx (i)] = 0;
+                      }
+                    else
+                      expected_visit[ridx (i)]++;
+                  }
+                if (end_of_zeros)
+                  {
+                    max_sgn[ridx (i)] = 1;
+                    nel += nc - j;
+                  }
+              }
+          }
+
+      for (octave_idx_type i = 0; i < nr; i++)
+        if (max_sgn[i] < 0)
+          nel += expected_visit[i];
+
+      result = SparseMatrix (nr, nc, nel);
+      octave_idx_type ii = 0;
+      result.xcidx (0) = 0;
+
+      octave_idx_type i = cidx (0);
+      for (octave_idx_type ir = 0; ir < nr; ir++)
+        {
+          idx_arg.elem (ir, 0) = 0;
+          if (i < cidx (1) && ridx (i) == ir)
+            {
+              result.xdata (ii) = data (i++);
+              result.xridx (ii++) = ir;
+            }
+        }
+      result.xcidx (1) = ii;
+      octave_idx_type r = result.cidx (0);
+
+      for (octave_idx_type j = 1; j < nc; j++)
+        {
+          for (octave_idx_type ir = 0; ir < nr; ir++)
+            {
+              double tmp_max = (r < result.cidx (j) && result.ridx (r) == ir
+                                ? result.data (r++) : 0.);
+              double tmp = i < cidx (j+1) && ridx (i) == ir ? data (i++) : 0.;
+              if (tmp > tmp_max
+                  || (includenan == octave::math::isnan (tmp)
+                      && includenan != octave::math::isnan (tmp_max)))
+                {
+                  idx_arg.elem (ir, j) = j;
+                  if (tmp != 0.)
+                    {
+                      result.xdata (ii) = tmp;
+                      result.xridx (ii++) = ir;
+                    }
+                }
+              else
+                {
+                  idx_arg.elem (ir, j) = idx_arg.elem (ir, j - 1);
+                  if (tmp_max != 0.)
+                    {
+                      result.xdata (ii) = tmp_max;
+                      result.xridx (ii++) = ir;
+                    }
+                }
+            }
+          result.xcidx (j+1) = ii;
+        }
+    }
+
+  return result;
+}
+
+SparseMatrix
+SparseMatrix::cummin (int dim, bool includenan) const
+{
+  SparseMatrix result;
+  dim_vector dv = dims ();
+  octave_idx_type nr = dv(0);
+  octave_idx_type nc = dv(1);
+
+  if (dim >= dv.ndims ())
+    return *this;
+
+  if (dim < 0)
+    dim = dv.first_non_singleton ();
+
+  if (nr == 0 || nc == 0 || dim >= dv.ndims ())
+    return SparseMatrix (nr, nc);
+
+  if (dim == 0)
+    {
+      octave_idx_type nel = 0;
+      for (octave_idx_type j = 0; j < nc; j++)
+        {
+          octave_idx_type i = cidx (j);
+          if (i < cidx (j+1) && ridx (i) == 0)
+            {
+              octave_idx_type expected_r = 0;
+              for (; i < cidx (j+1) && ridx (i) == expected_r; i++)
+                {
+                  if (data (i) < 0. || (octave::math::isnan (data (i))
+                                        && includenan))
+                    break;
+                  expected_r++;
+                }
+
+              if (i < cidx (j+1) && ridx (i) == expected_r)
+                {
+                  nel += nr;
+                  continue;
+                }
+              nel += expected_r;
+            }
+          for (; i < cidx (j+1); i++)
+            if (data (i) < 0. || (octave::math::isnan (data (i))
+                                  && includenan))
+              {
+                nel += nr - ridx (i);
+                break;
+              }
+        }
+
+      result = SparseMatrix (nr, nc, nel);
+      octave_idx_type ii = 0;
+      result.xcidx (0) = 0;
+
+      for (octave_idx_type j = 0; j < nc; j++)
+        {
+          octave_idx_type i = cidx (j);
+          if (i < cidx (j+1))
+            {
+              octave_idx_type last = 0;
+              bool zero_found = ridx (i) > 0;
+              double tmp_min = zero_found ? 0. : data (i++);
+
+              if (! zero_found
+                  && ((i < cidx (j+1) && ridx (i) > 1)
+                      || (i == cidx (j+1) && nr >= 2)))
+                {
+                  zero_found = true;
+                  if (0. < tmp_min
+                      || (octave::math::isnan (tmp_min) && ! includenan))
+                    {
+                      result.xdata (ii) = tmp_min;
+                      result.xridx (ii++) = 0;
+                      last = 1;
+                      tmp_min = 0.;
+                    }
+                }
+
+              for (; i < cidx (j+1); i++)
+                {
+                  if (data (i) < tmp_min
+                      || (includenan == octave::math::isnan (data (i))
+                          && includenan != octave::math::isnan (tmp_min)))
+                    {
+                      if (tmp_min != 0.)
+                        for (; last < ridx (i); last++)
+                          {
+                            result.xdata (ii) = tmp_min;
+                            result.xridx (ii++) = last;
+                          }
+                      last = ridx (i);
+                      tmp_min = data (i);
+                    }
+                  if (! zero_found
+                      && ((i + 1 < cidx (j+1) && ridx (i+1) > ridx (i) + 1)
+                          || (i + 1 == cidx (j+1) && ridx (i) < nr - 1)))
+                    {
+                      zero_found = true;
+                      if (0. < tmp_min
+                          || (octave::math::isnan (tmp_min) && ! includenan))
+                        {
+                          for (; last < ridx (i) + 1; last++)
+                            {
+                              result.xdata (ii) = tmp_min;
+                              result.xridx (ii++) = last;
+                            }
+                          last = ridx (i) + 1;
+                          tmp_min = 0.;
+                        }
+                    }
+                }
+              if (tmp_min != 0.)
+                for (; last < nr; last++)
+                  {
+                    result.xdata (ii) = tmp_min;
+                    result.xridx (ii++) = last;
+                  }
+            }
+          result.xcidx (j+1) = ii;
+        }
+    }
+  else
+    {
+      octave_idx_type nel = 0;
+
+      OCTAVE_LOCAL_BUFFER (octave_idx_type, expected_visit, nr);
+      OCTAVE_LOCAL_BUFFER (int8_t, min_sgn, nr);
+
+      for (octave_idx_type i = 0; i < nr; i++)
+        {
+          expected_visit[i] = 0;
+          min_sgn[i] = 1;
+        }
+
+      for (octave_idx_type j = 0; j < nc; j++)
+        for (octave_idx_type i = cidx (j); i < cidx (j+1); i++)
+          {
+            if (min_sgn[ridx (i)] >= 0)
+              {
+                bool end_of_zeros = (data (i) < 0.
+                                     || (octave::math::isnan (data (i))
+                                         && includenan));
+
+                if (min_sgn[ridx (i)] > 0)
+                  {
+                    if (expected_visit[ridx (i)] < j || end_of_zeros)
+                      {
+                        nel += expected_visit[ridx (i)];
+                        if (expected_visit[ridx (i)] < j)
+                          min_sgn[ridx (i)] = 0;
+                      }
+                    else
+                      expected_visit[ridx (i)]++;
+                  }
+                if (end_of_zeros)
+                  {
+                    min_sgn[ridx (i)] = 1;
+                    nel += nc - j;
+                  }
+              }
+          }
+
+      for (octave_idx_type i = 0; i < nr; i++)
+        if (min_sgn[i] > 0)
+          nel += expected_visit[i];
+
+      result = SparseMatrix (nr, nc, nel);
+      octave_idx_type ii = 0;
+      result.xcidx (0) = 0;
+
+      for (octave_idx_type i = cidx (0); i < cidx (1); i++)
+        {
+          result.xdata (ii) = data (i);
+          result.xridx (ii++) = ridx (i);
+        }
+      result.xcidx (1) = ii;
+
+      for (octave_idx_type j = 1; j < nc; j++)
+        {
+          octave_idx_type i = cidx (j);
+          octave_idx_type i_max = cidx (j+1);
+          bool i_lt_max = i < i_max;
+
+          octave_idx_type r = result.cidx (j-1);
+          octave_idx_type r_max = result.cidx (j);
+          bool r_lt_max = r < r_max;
+
+          while (i_lt_max || r_lt_max)
+            {
+              octave_quit ();
+              double i_val, r_val;
+              octave_idx_type row;
+
+              if (! r_lt_max || (i_lt_max && ridx (i) < result.ridx (r)))
+                {
+                  i_val = data (i);
+                  r_val = 0.;
+                  row = ridx (i++);
+                  i_lt_max = i < i_max;
+                }
+              else if (! i_lt_max || (r_lt_max && result.ridx (r) < ridx (i)))
+                {
+                  i_val = 0.;
+                  r_val = result.data (r);
+                  row = result.ridx (r++);
+                  r_lt_max = r < r_max;
+                }
+              else
+                {
+                  i_val = data (i);
+                  r_val = result.data (r);
+                  row = ridx (i++);
+                  i_lt_max = i < i_max;
+                  r++;
+                  r_lt_max = r < r_max;
+                }
+
+              double tmp;
+              if (includenan)
+                tmp = r_val <= i_val ? r_val : (octave::math::isnan (r_val)
+                                                ? r_val : i_val);
+              else
+                tmp = octave::math::min (r_val, i_val);
+              if (tmp != 0.)
+                {
+                  result.data (ii) = tmp;
+                  result.ridx (ii++) = row;
+                }
+            }
+          result.xcidx (j+1) = ii;
+        }
+    }
+
+  return result;
+}
+
+SparseMatrix
+SparseMatrix::cummin (Array<octave_idx_type>& idx_arg,
+                      int dim, bool includenan) const
+{
+  SparseMatrix result;
+  dim_vector dv = dims ();
+  octave_idx_type nr = dv(0);
+  octave_idx_type nc = dv(1);
+
+  if (dim >= dv.ndims ())
+    {
+      idx_arg.resize (dim_vector (nr, nc), 0);
+      return *this;
+    }
+
+  if (dim < 0)
+    dim = dv.first_non_singleton ();
+
+  idx_arg.resize (dim_vector (nr, nc));
+
+  if (nr == 0 || nc == 0 || dim >= dv.ndims ())
+    return SparseMatrix (nr, nc);
+
+  if (dim == 0)
+    {
+      octave_idx_type nel = 0;
+      for (octave_idx_type j = 0; j < nc; j++)
+        {
+          octave_idx_type i = cidx (j);
+          if (i < cidx (j+1) && ridx (i) == 0)
+            {
+              octave_idx_type expected_r = 0;
+              for (; i < cidx (j+1) && ridx (i) == expected_r; i++)
+                {
+                  if (data (i) < 0. || (octave::math::isnan (data (i))
+                                        && includenan))
+                    break;
+                  expected_r++;
+                }
+
+              if (i < cidx (j+1) && ridx (i) == expected_r)
+                {
+                  nel += nr;
+                  continue;
+                }
+              nel += expected_r;
+            }
+          for (; i < cidx (j+1); i++)
+            if (data (i) < 0. || (octave::math::isnan (data (i))
+                                  && includenan))
+              {
+                nel += nr - ridx (i);
+                break;
+              }
+        }
+
+      result = SparseMatrix (nr, nc, nel);
+      octave_idx_type ii = 0;
+      result.xcidx (0) = 0;
+      octave_idx_type i = cidx (0);
+
+      for (octave_idx_type j = 0; j < nc; j++)
+        {
+          double tmp_min = i < cidx (j+1) && ridx (i) == 0 ? data (i++) : 0.;
+          idx_arg.elem (0, j) = 0;
+          if (tmp_min != 0.)
+            {
+              result.xdata (ii) = tmp_min;
+              result.xridx (ii++) = 0;
+            }
+
+          for (octave_idx_type ir = 1; ir < nr; ir++)
+            {
+              double tmp = i < cidx (j+1) && ridx (i) == ir ? data (i++) : 0.;
+
+              if (tmp < tmp_min
+                  || (includenan == octave::math::isnan (tmp)
+                      && includenan != octave::math::isnan (tmp_min)))
+                {
+                  tmp_min = tmp;
+                  idx_arg.elem (ir, j) = ir;
+                }
+              else
+                idx_arg.elem (ir, j) = idx_arg.elem (ir - 1, j);
+              if (tmp_min != 0.)
+                {
+                  result.xdata (ii) = tmp_min;
+                  result.xridx (ii++) = ir;
+                }
+            }
+
+          result.xcidx (j+1) = ii;
+        }
+    }
+  else
+    {
+      octave_idx_type nel = 0;
+
+      OCTAVE_LOCAL_BUFFER (octave_idx_type, expected_visit, nr);
+      OCTAVE_LOCAL_BUFFER (int8_t, min_sgn, nr);
+
+      for (octave_idx_type i = 0; i < nr; i++)
+        {
+          expected_visit[i] = 0;
+          min_sgn[i] = 1;
+        }
+
+      for (octave_idx_type j = 0; j < nc; j++)
+        for (octave_idx_type i = cidx (j); i < cidx (j+1); i++)
+          {
+            if (min_sgn[ridx (i)] >= 0)
+              {
+                bool end_of_zeros = (data (i) < 0.
+                                     || (octave::math::isnan (data (i))
+                                         && includenan));
+
+                if (min_sgn[ridx (i)] > 0)
+                  {
+                    if (expected_visit[ridx (i)] < j || end_of_zeros)
+                      {
+                        nel += expected_visit[ridx (i)];
+                        if (expected_visit[ridx (i)] < j)
+                          min_sgn[ridx (i)] = 0;
+                      }
+                    else
+                      expected_visit[ridx (i)]++;
+                  }
+                if (end_of_zeros)
+                  {
+                    min_sgn[ridx (i)] = 1;
+                    nel += nc - j;
+                  }
+              }
+          }
+
+      for (octave_idx_type i = 0; i < nr; i++)
+        if (min_sgn[i] > 0)
+          nel += expected_visit[i];
+
+      result = SparseMatrix (nr, nc, nel);
+      octave_idx_type ii = 0;
+      result.xcidx (0) = 0;
+
+      octave_idx_type i = cidx (0);
+      for (octave_idx_type ir = 0; ir < nr; ir++)
+        {
+          idx_arg.elem (ir, 0) = 0;
+          if (i < cidx (1) && ridx (i) == ir)
+            {
+              result.xdata (ii) = data (i++);
+              result.xridx (ii++) = ir;
+            }
+        }
+      result.xcidx (1) = ii;
+      octave_idx_type r = result.cidx (0);
+
+      for (octave_idx_type j = 1; j < nc; j++)
+        {
+          for (octave_idx_type ir = 0; ir < nr; ir++)
+            {
+              double tmp_min = (r < result.cidx (j) && result.ridx (r) == ir
+                                ? result.data (r++) : 0.);
+              double tmp = i < cidx (j+1) && ridx (i) == ir ? data (i++) : 0.;
+              if (tmp < tmp_min
+                  || (includenan == octave::math::isnan (tmp)
+                      && includenan != octave::math::isnan (tmp_min)))
+                {
+                  idx_arg.elem (ir, j) = j;
+                  if (tmp != 0.)
+                    {
+                      result.xdata (ii) = tmp;
+                      result.xridx (ii++) = ir;
+                    }
+                }
+              else
+                {
+                  idx_arg.elem (ir, j) = idx_arg.elem (ir, j - 1);
+                  if (tmp_min != 0.)
+                    {
+                      result.xdata (ii) = tmp_min;
+                      result.xridx (ii++) = ir;
+                    }
+                }
+            }
+          result.xcidx (j+1) = ii;
+        }
+    }
+
+  return result;
+}
+
+/*
+
+%!test
+%! x = kron (eye (4), sparse (1, 1, 1, 2^14, 2^14));
+%! assert (sum (sum (cummax (x, 1))), sparse (2^17 + 2^15));
+%! assert (sum (sum (cummax (x, 2))), sparse (2^17 + 2^15));
+%! assert (sum (sum (cummin (x, 1))), sparse (1));
+%! assert (sum (sum (cummin (x, 2))), sparse (1));
+
+*/
+
 RowVector
 SparseMatrix::row (octave_idx_type i) const
 {
@@ -7734,7 +8639,7 @@ operator * (const SparseMatrix& a, const
     return T (nr, nc);
 
 SparseMatrix
-min (double d, const SparseMatrix& m)
+min (double d, const SparseMatrix& m, bool includenan)
 {
   SparseMatrix result;
 
@@ -7750,7 +8655,11 @@ min (double d, const SparseMatrix& m)
       for (octave_idx_type j = 0; j < nc; j++)
         for (octave_idx_type i = m.cidx (j); i < m.cidx (j+1); i++)
           {
-            double tmp = octave::math::min (d, m.data (i));
+            double tmp = m.data (i);
+            if (! includenan)
+              tmp = octave::math::min (d, tmp);
+            else if (d < tmp)
+              tmp = d;
             if (tmp != 0.)
               {
                 octave_idx_type idx = m.ridx (i) + j * nr;
@@ -7761,11 +8670,21 @@ min (double d, const SparseMatrix& m)
     }
   else
     {
-      octave_idx_type nel = 0;
-      for (octave_idx_type j = 0; j < nc; j++)
-        for (octave_idx_type i = m.cidx (j); i < m.cidx (j+1); i++)
-          if (octave::math::min (d, m.data (i)) != 0.)
-            nel++;
+      if (octave::math::isnan (d) && includenan)
+        return SparseMatrix (nr, nc, d);
+
+      octave_idx_type nel;
+      if (d > 0. || octave::math::isnan (d))
+        nel = m.nnz ();
+      else
+        {
+          nel = 0;
+          for (octave_idx_type j = 0; j < nc; j++)
+            for (octave_idx_type i = m.cidx (j); i < m.cidx (j+1); i++)
+              if (m.data (i) < 0.
+                  || (includenan && octave::math::isnan (m.data (i))))
+                nel++;
+        }
 
       result = SparseMatrix (nr, nc, nel);
 
@@ -7775,7 +8694,11 @@ min (double d, const SparseMatrix& m)
         {
           for (octave_idx_type i = m.cidx (j); i < m.cidx (j+1); i++)
             {
-              double tmp = octave::math::min (d, m.data (i));
+              double tmp = m.data (i);
+              if (! includenan)
+                tmp = octave::math::min (d, tmp);
+              else if (d < tmp)
+                tmp = d;
 
               if (tmp != 0.)
                 {
@@ -7791,13 +8714,30 @@ min (double d, const SparseMatrix& m)
 }
 
 SparseMatrix
-min (const SparseMatrix& m, double d)
-{
-  return min (d, m);
+min (const SparseMatrix& m, double d, bool includenan)
+{
+  if (! octave::math::isnan (d))
+    return min (d, m, includenan);
+
+  if (! includenan)
+    return m;
+
+  octave_idx_type nr = m.rows ();
+  octave_idx_type nc = m.columns ();
+
+  EMPTY_RETURN_CHECK (SparseMatrix);
+
+  SparseMatrix result (nr, nc, d);
+  for (octave_idx_type j = 0; j < nc; j++)
+    for (octave_idx_type i = m.cidx (j); i < m.cidx (j+1); i++)
+      if (octave::math::isnan (m.data (i)))
+        result.xdata (m.ridx (i) + j * nr) = m.data (i);
+
+  return result;
 }
 
 SparseMatrix
-min (const SparseMatrix& a, const SparseMatrix& b)
+min (const SparseMatrix& a, const SparseMatrix& b, bool includenan)
 {
   SparseMatrix r;
 
@@ -7827,7 +8767,11 @@ min (const SparseMatrix& a, const Sparse
               octave_quit ();
               if ((! jb_lt_max) || (ja_lt_max && (a.ridx (ja) < b.ridx (jb))))
                 {
-                  double tmp = octave::math::min (a.data (ja), 0.);
+                  double tmp = a.data (ja);
+                  if (! includenan)
+                    tmp = octave::math::min (tmp, 0.);
+                  else if (0. < tmp)
+                    tmp = 0.;
                   if (tmp != 0.)
                     {
                       r.ridx (jx) = a.ridx (ja);
@@ -7840,7 +8784,11 @@ min (const SparseMatrix& a, const Sparse
               else if ((! ja_lt_max)
                        || (jb_lt_max && (b.ridx (jb) < a.ridx (ja))))
                 {
-                  double tmp = octave::math::min (0., b.data (jb));
+                  double tmp = b.data (jb);
+                  if (! includenan)
+                    tmp = octave::math::min (0., tmp);
+                  else if (0. < tmp)
+                    tmp = 0.;
                   if (tmp != 0.)
                     {
                       r.ridx (jx) = b.ridx (jb);
